<?php
namespace FM\Service;

use FM\Factory\NovoChecklistFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;

class NovoChecklistService {
    
    protected $NovoChecklistFactory;
    protected $Environment;
    protected $newCode;
    
    public function __construct (NovoChecklistFactory $NovoChecklistFactory, Environment $Environment, NewCode $newCode) {
        $this->NovoChecklistFactory  = $NovoChecklistFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }

    public function buscaNomeLocais(){
        
        $local = $this->NovoChecklistFactory->buscaNomeLocais();
        return $local;
    }
    
    public function filtroItens(){
        
        $filtroItens = $this->NovoChecklistFactory->filtroItens();
        
        return $filtroItens;
    }
    
    public function filtroTags($titulo){
        $variavel = implode(',', $titulo);
        // debugApi([$variavel]);
        $filtroItens = $this->NovoChecklistFactory->filtroTags($variavel);
        
        return $filtroItens;
    }    

    public function buscaDadosCardPadrao(){
        
        $dados =  $this->NovoChecklistFactory->buscaDadosCardPadrao();
        
        return $dados;
        
    }
    
    public function buscaDadosAtividadeseCriterios($params){
        $validParam = '';
        if($params['inputAtividades'] != '' && $params['inputAtividades'] != null ) {
            $validParam = " WHERE UPPER(FCM_ATIVIDADE.NMATIVIDADE) LIKE UPPER('%".$params['inputAtividades']."%')";
        }
        
        $dados =  $this->NovoChecklistFactory->buscaDadosAtividadeseCriterios($validParam);
        
        $colecao = array();
        foreach($dados as $ind=>$informacoes){
            $colecao[$ind] = $informacoes;
            $parametroAtividade = array(
             "NRATIVIDADE" => $informacoes['NRATIVIDADE']
            );
            $resquisicao = $this->NovoChecklistFactory->buscaTarefas($parametroAtividade);
            foreach($resquisicao as $ind2=>$tarefas){
                $parametroTarefa = array(
                 "NRTAREFA" => $tarefas['NRTAREFA']
                );
                $requisicaoCriterio = $this->NovoChecklistFactory->buscaCriterioAtividades($parametroTarefa);
                $requisicaotags = $this->NovoChecklistFactory->buscaTagsAtividades($parametroTarefa);
                $colecao[$ind][$ind2] = $tarefas;
                $colecao[$ind][$ind2]['CRITERIOS'] = $requisicaoCriterio;
                $colecao[$ind][$ind2]['TAGS'] = $requisicaotags;
            }
            
        }
        // debugApi([$colecao]);
        return $colecao;
    }
    
    public function buscaNomeLocal($params){
        $validParam = '';
        if($params['inputLocal'] != '' && $params['inputLocal'] != null ) {
            $validParam = " WHERE UPPER(FCM_CHECKLIST.NMCHECKLIST) LIKE UPPER('%".$params['inputLocal']."%')";
        }
        $dados =  $this->NovoChecklistFactory->buscaNomeLocal($validParam);
        // debugApi([$dados]);
        return $dados;
        
    }
    
    public function buscaDadosCardAtividades(){
        
        $dados =  $this->NovoChecklistFactory->buscaDadosCardAtividades();
        
        return $dados;
        
    }
    
    public function insertNovaAtividadeBase($nratividade, $nmatividade, $nrtarefa, $nmtarefa, $dspopservico, $nrcriteriotarefa, $dscriteriotarefa, $idtipocriterio, $nrtagstarefa, $dstagstarefa ){
        
        $nrorcaescopodoc = $this->newCode->getCodeByTableName("", $nrorg, 1, 10, true);
        //criar tres arrays para cada requisição

        $parametrosAtividades =  array (
            
            "NRATIVIDADE" => $nratividade,
            "NMATIVIDADE" => $nmatividade,
        );
        
        $parametrosTarefas =  array (
            
            "NRTAREFA" => $nrtarefa,
            "NMTAREFA" => $nmtarefa,
            "NRATIVIDADE" => $nratividade,
            "DSPOPSERVICO" => $dspopservico
        );
        
        $parametrosCriterio =  array (
            
            "NRCRITERIOTAREFA" => $nrcriteriotarefa,
            "DSCRITERIOTAREFA" => $dscriteriotarefa,
            "NRTAREFA" => $nrtarefa,
            "IDTIPOCRITERIO" => $idtipocriterio
        );
        
        $parametrosTags =  array (
            
            "NRTAGSTAREFA" => $nrtagstarefa,
            "NRTAREFA" => $nrtarefa,
            "DSTAGSTAREFA" => $dstagstarefa
        );
        
        //chamar elas no factory de forma logica, no caso na ordem atividade, tarefa, critério,tag.
        $novaAtividade =  $this->NovoChecklistFactory->insertNovaAtividadeBase($parametrosAtividades);
        $novaTarefa = $this->NovoChecklistFactory->insertNovaTarefaBase($parametrosTarefas);
        $novoCriterio = $this->NovoChecklistFactory->insertNovoCriterioBase($parametrosCriterio);
        $novoTag = $this->NovoChecklistFactory->insertNovoTagBase($parametrosTags);
        
        return 'OK';
    }
    
    public function insertNovoChecklistBase(/*Passar parametros vindos do controler aqui*/) {
        
        
         $nrorcaescopodoc = $this->newCode->getCodeByTableName("", $nrorg, 1, 10, true);
         
         $parametroNovoChecklist =  array(
             "NRATIVIDADECHK" => $nratividadechk,
             "NRATIVIDADE" => $nratividade,
             "NRCHECKLIST" => $nrchecklist,
             "IDATIVO" => $idativo,
             "NRORG" => $nrorg,
             "DTINCLUSAO" => $dtinclusao,
             "NRTAREFACHK" => $nrtarefachk,
             "NRTAREFA" => $nrtarefa,
             "NRCRITERIOTAREFACHK" => $nrcriteriotarefachk,
             "NRCRITERIOTAREFA" => $nrcriteriotarefa,
             "NRTAGSTAREFA" => $nrtagschktarefa
        );
        
        $novoChecklist =  $this->NovoChecklistFactory->insertNovoChecklistBase($parametroNovoChecklist);
         
    }
    
    public function criaGruposTags($parametro) {
        $variavel = array();
        foreach($parametro as $tarefa){
            $variavel[] = $tarefa['value'];
        }
        $variavel = implode(',', $variavel);
        $grupoTags = $this->NovoChecklistFactory->criaGruposTags($variavel);
        $teste = array($grupoTags);
        $teste =  $teste[0];
        $resposta = $teste;
        foreach($teste as $index=>$grupo){
            // debugApi([$index,$grupo]);
            $dadosInformacao = array(
                "NRTAREFA" => $variavel,
                "DSTAGSTAREFA" => $grupo['DSTAGSTAREFA']
            );
            $teste[$index]['list'] = $this->NovoChecklistFactory->buscaDadosCriteriosNaoConformidades($dadosInformacao);
            $resposta[$index]['list'] = array();
        }
        foreach($teste as $index=>$value){
            foreach($teste[$index]['list'] as $index1=>$value1){
                $posicao =  $index1;
                foreach($resposta[$index]['list'] as $index2=>$value2){
                    if($value2['NRATIVIDADE'] == $value1['NRATIVIDADE'] && $index1 > $index2){
                        $posicao = $index2;
                    }
                }
                if($posicao ==  $index1) {
                   $resposta[$index]['list'][] = $value1;
                    // var_dump($resposta[$index]['list'][count($resposta[$index]['list']) -1]);
                  $resposta[$index]['list'][count($resposta[$index]['list']) -1]['list'][] = array(
                      "NRCRITERIOTAREFA" => $value1['NRCRITERIOTAREFA'],
                      "DSCRITERIOTAREFA" => $value1['DSCRITERIOTAREFA'],
                      "ATIVO" => false
                      );
                } else {
                  // $resposta[$index]['list'][$posicao] = $value1;
                  $resposta[$index]['list'][$posicao]['list'][] = array(
                      "NRCRITERIOTAREFA" => $value1['NRCRITERIOTAREFA'],
                      "DSCRITERIOTAREFA" => $value1['DSCRITERIOTAREFA'],
                      "ATIVO" => false
                      );
                }
            }
        }
         // debugApi([$resposta]);
        return $resposta;
    }
    
    public function buscaDadosCriteriosNaoConformidades($parametro1, $parametro2){
        $variavel1 = implode(',', $parametro1);
        $variavel2 = implode(',', $parametro2);
        
        $criterios = $this->NovoChecklistFactory->buscaDadosCriteriosNaoConformidades($variavel, $variavel2);
        
        return $criterios;
    }
    // função responsável por pegar as informações ao edicar card local
    public function getDadosEditCard($parametro){
        $param = array(
            "NRCHECKLIST" => $parametro
        );
        $retorno =  array();
        $dados =  $this->NovoChecklistFactory->getTipoLocal($param);

        $retorno['NRTIPOLOCALCLI'] = $dados[0]['NRTIPOLOCALCLI'];
        $retorno['NMTIPOLOCALCLI'] = $dados[0]['NMTIPOLOCALCLI'];
        $retorno['NRCHECKLIST'] = $dados[0]['NRCHECKLIST'];
        $retorno['NMCHECKLIST'] = $dados[0]['NMCHECKLIST'];
        $retorno['DSCHECKLIST'] = $dados[0]['DSCHECKLIST'];
        
        $dadosItens =  $this->NovoChecklistFactory->getItensEditCard($param);

        $contador = 0;
        foreach($dadosItens as $itens){
            $contadorTarefa = 0;
            $retorno['ITEM'][$contador] = array(
                "NRATIVIDADECHK" => $itens['NRATIVIDADECHK'],
                "NRATIVIDADE" => $itens['NRATIVIDADE'],
                "NRCHECKLIST" => $itens['NRCHECKLIST'],
                "NMATIVIDADE" => $itens['NMATIVIDADE']
            );
            
            $param2 = array(
                "NRATIVIDADECHK" => $itens['NRATIVIDADECHK']
            );
            
            $dadostarefas =  $this->NovoChecklistFactory->getTarefasEditCard($param2);
            foreach($dadostarefas as $tarefas){
                
                $retorno['ITEM'][$contador]['TAREFA'][$contadorTarefa] = array(
                    "NRTAREFACHK" => $tarefas['NRTAREFACHK'],
                    "NRTAREFA" => $tarefas['NRTAREFA'],
                    "NMTAREFA" => $tarefas['NMTAREFA']
                );
                
                $param3 = array(
                    "NRTAREFACHK" => $tarefas['NRTAREFACHK']
                );

                $dadostags =  $this->NovoChecklistFactory->getGrupoTagseditCard($param3);

                $contadorTag = 0;
                foreach($dadostags as $tags){
                    
                    $retorno['ITEM'][$contador]['TAREFA'][$contadorTarefa]['TAGS'][$contadorTag] = array(
                         "NRTAGSCHKTAREFA" => $tags['NRTAGSCHKTAREFA'],
                         "NRTAGSTAREFA" => $tags['NRTAGSTAREFA'],
                         "DSTAGSTAREFA" => $tags['DSTAGSTAREFA'],
                         "PARENT" => $tarefas['NRTAREFA']
                    );
                    
                    $contadorTag ++;
                }
                $contadorCriterio = 0;
                $dadosCriterios =  $this->NovoChecklistFactory->getCriterioEditCard($param3);
                foreach($dadosCriterios as $criterios){

                    $retorno['ITEM'][$contador]['TAREFA'][$contadorTarefa]['CRITERIOS'][$contadorCriterio] = array(
                        "NRCRITERIOTAREFACHK" => $criterios['NRCRITERIOTAREFACHK'],
                        "NRCRITERIOTAREFA" => $criterios['NRCRITERIOTAREFA'],
                        "DSCRITERIOTAREFA" => $criterios['DSCRITERIOTAREFA'],
                        "PARENT" => $tarefas['NRTAREFA']
                    );
                    $contadorCriterio ++;
                    
                }
                
                $contadorRelacionamento = 0;
                $dadosRelac = $this->NovoChecklistFactory->getRelac($param3);
                foreach($dadosRelac as $dados){
                    $retorno['ITEM'][$contador]['TAREFA'][$contadorTarefa]['RELACCRITTAG'][$contadorRelacionamento] = array(
                        "NRCRITERIOTAREFACHK" => $dados['NRCRITERIOTAREFACHK'],
                        "NRCRITERIOTAREFA" => $dados['NRCRITERIOTAREFA'],
                        "NRTAGSCHKTAREFA" => $dados['NRTAGSCHKTAREFA'],
                        "PARENT" => $tarefas['NRTAREFA']
                    );
                    $contadorRelacionamento ++;
                }
                $contadorTarefa ++;
            }
            $contador ++;
        }
        
       // debugApi([$retorno["ITEM"][0]["TAREFA"][0]["RELACCRITTAG"][0]]);
       // ["DSTAGSTAREFA"]["NRTAGSTAREFA"]
       // debugApi([$retorno]);
        return $retorno;
        
    }
    
    // função responsavel por pegar os dados do card ao acionar o botão de copiar
    public function getDadosCopiaCard($checklist, $nrorg){
        $param = array(
        "NRCHECKLIST" => $checklist
        );
        
        $buscaDadosChecklist = $this->NovoChecklistFactory->getDadosCopiaCard($param);
        $codnrchecklist = $this->newCode->getCodeByTableName("FCM_CHECKLIST", $nrorg, 1, 10, true);
        
        foreach($buscaDadosChecklist as $dadosCheckList){
            $retornoChecklist = array(
            "NRCHECKLIST" => $codnrchecklist,
            "NMCHECKLIST" => $dadosCheckList["NMCHECKLIST"],
            "DSCHECKLIST" => $dadosCheckList["DSCHECKLIST"],
            "NRSETOR" => $dadosCheckList["NRSETOR"],
            "NRCRITICIDADECHK" => $dadosCheckList["NRCRITICIDADECHK"],
            "NRHABILIDADE" => $dadosCheckList["NRHABILIDADE"],
            "NRTIPOLOCALCLI" =>$dadosCheckList["NRTIPOLOCALCLI"]
            );
            
            $this->NovoChecklistFactory->insertNovoChecklistBase($retornoChecklist);
            $buscaRelacLocalChk = $this->NovoChecklistFactory->getRelacLocalChk($param);
            
            foreach($buscaRelacLocalChk as $dadosRelac) {
                $codnrRelac = $this->newCode->getCodeByTableName("FCM_RELACLOCALCHK", $nrorg, 1, 10, true);
                
                $retornoRelac = array(
                "NRRELACLOCALCHK" => $codnrRelac,
                "NRLOCALCLIENTE" => $dadosRelac["NRLOCALCLIENTE"],
                "NRCHECKLIST" => $codnrchecklist,
                "IDCHECKLISTPADRAO" => $dadosRelac["IDCHECKLISTPADRAO"]
                );
                
                $this->NovoChecklistFactory->insertRelacLocalChk($retornoRelac);
            }
        }
        
        
        $selectAtividadeBase = $this->NovoChecklistFactory->getItensEditCard($param);
  
        foreach($selectAtividadeBase as $atividades){
            
            $codnratividade = $this->newCode->getCodeByTableName("FCM_ATIVIDADECHK", $nrorg, 1, 10, true);
            
            $retornoAtividade =  array(
                "NRATIVIDADECHK" => $codnratividade,
                "NRATIVIDADE" => $atividades["NRATIVIDADE"], 
                "NRCHECKLIST" => $codnrchecklist
            );
            
        $this->NovoChecklistFactory->insertNovaAtividadeBase($retornoAtividade);
        
        $param =  array(
            
          "NRATIVIDADECHK" => $atividades["NRATIVIDADECHK"]
        );
        
        $selectTarefaBase = $this->NovoChecklistFactory->getTarefasEditCard($param);
        
        foreach($selectTarefaBase as $tarefas){
            $codnraTarefa = $this->newCode->getCodeByTableName("FCM_TAREFACHK", $nrorg, 1, 10, true);
            
            $retornoTarefa =  array(
                "NRTAREFACHK" => $codnraTarefa,
                "NRTAREFA" => $tarefas["NRTAREFA"],
                "NRATIVIDADECHK" => $codnratividade,
                "NRCHECKLIST" => $codnrchecklist
            );
            
            $this->NovoChecklistFactory->insertNovaTarefaBase($retornoTarefa);
            
            $param = array(
                "NRTAREFACHK" =>$tarefas["NRTAREFACHK"]
            );
            
            $selectRelCriTag = $this->NovoChecklistFactory->getRelac($param);
            
            foreach($selectRelCriTag as $relac){
                
                $codRelCriTag = $this->newCode->getCodeByTableName("FCM_RELCRITERIOTAGTAREFACHK", $nrorg, 1, 10, true);
                
                $retornoRelac = array(
                    "RELCRITERIOTAGTAREFACHK" => $codRelCriTag,
                    "NRCRITERIOTAREFACHK" => $relac["NRCRITERIOTAREFACHK"],
                    "NRTAGSCHKTAREFA" => $relac["NRTAGSCHKTAREFA"],
                    "NRTAREFACHK" => $codnraTarefa
                );
                $this->NovoChecklistFactory->insertRelacCritTag($retornoRelac);
            }
            
            $selectCriterio = $this->NovoChecklistFactory->getCriterioEditCard($param);
            
            foreach($selectCriterio as $criterio){
                
                $codnraCriterio = $this->newCode->getCodeByTableName("FCM_CRITERIOTAREFACHK", $nrorg, 1, 10, true);
                
                $retornoCriterio =  array(
                    "NRCRITERIOTAREFACHK" => $codnraCriterio,
                    "NRCRITERIOTAREFA" => $criterio["NRCRITERIOTAREFA"],
                    "NRTAREFACHK" => $codnraTarefa
                );
                
                $this->NovoChecklistFactory->insertNovoCriterioBase($retornoCriterio);
                
                $retornoRelCriterio =  array(
                    "NRCRITERIOTAREFACHK" => $codnraCriterio,
                    "NRTAREFACHK" => $codnraTarefa,
                    "NRCRITERIOTAREFACHKOLD" => $criterio["NRCRITERIOTAREFACHK"]
                );
                $this->NovoChecklistFactory->updateRelCriterio($retornoRelCriterio);
            }
            
            $selectTAG = $this->NovoChecklistFactory->getGrupoTagseditCard($param);

            foreach($selectTAG as $tag){
                
                $codnraTag = $this->newCode->getCodeByTableName("FCM_TAGSCHKTAREFA", $nrorg, 1, 10, true);
                
                $retornoTag =  array(
                    "NRTAGSCHKTAREFA" => $codnraTag,
                    "NRTAGSTAREFA" => $tag["NRTAGSTAREFA"],
                    "NRTAREFACHK" => $codnraTarefa
                );
                
                $this->NovoChecklistFactory->insertNovoTagBase($retornoTag);
                
                $retornoRelTag =  array(
                    "NRTAGSCHKTAREFA" => $codnraTag,
                    "NRTAREFACHK" => $codnraTarefa,
                    "NRTAGSCHKTAREFAOLD" => $tag["NRTAGSCHKTAREFA"]
                );
                $this->NovoChecklistFactory->updateRelTag($retornoRelTag);
            }
        
        }
        
    }
        // debugApi([$atividades]);
    }

    public function insertDadostarefaModal($parametro, $nrorg) {
        $nmatividade = $parametro["NMATIVIDADE"];
        $codnratividade = $this->newCode->getCodeByTableName("FCM_ATIVIDADE", $nrorg, 1, 10, true);
        $dadosAtividade =  array(
            "NRATIVIDADE" =>  $codnratividade,
            "NMATIVIDADE" => $nmatividade, 
            "DSICONEATIVIDADE" => null,
            "DSCORIDATIVIDADE" => $parametro['COLOR']
        );
        
        $this->NovoChecklistFactory->insertAtividade($dadosAtividade);
        
        foreach($parametro["TAREFAS"] as $tarefas){
            $codnrtarefas = $this->newCode->getCodeByTableName("FCM_TAREFA", $nrorg, 1, 10, true);
            $dadosTarefas = array(
                "NRTAREFA" => $codnrtarefas,
                "NMTAREFA" => $tarefas["NMTAREFA"],
                "NRATIVIDADE" => $codnratividade,
                "DSPOPSERVICO" =>$tarefas["DESCRICAO"]
            );
            
            $this->NovoChecklistFactory->insertTarefa($dadosTarefas);
            
            foreach($tarefas["CRITERIO"] as $criterios) {
                
                $codnrcriterios = $this->newCode->getCodeByTableName("FCM_CRITERIOTAREFA", $nrorg, 1, 10, true);
                
                $dadosCriterios =  array(
                    "NRCRITERIOTAREFA" => $codnrcriterios, 
                    "DSCRITERIOTAREFA" => $criterios,
                    "NRTAREFA" => $codnrtarefas,
                    "IDTIPOCRITERIO" => 1
                );
                
                $this->NovoChecklistFactory->insertCriterio($dadosCriterios);
    
            }
            foreach($tarefas["TAG"] as $tags) {
               $codnrtags = $this->newCode->getCodeByTableName("FCM_TAGSTAREFA", $nrorg, 1, 10, true); 
               
               $dadosTags = array(
                   "NRTAGSTAREFA" => $codnrtags,
                   "NRTAREFA" => $codnrtarefas,
                   "DSTAGSTAREFA" => $tags
                );
                
                $this->NovoChecklistFactory->insertTag($dadosTags);
            }
        }
        
    }
    
    public function insertDadosNovatarefa($parametro, $nrorg) {
        $nratividade = $parametro["NRATIVIDADE"];
        
        $nmtarefa = $parametro["NMTAREFA"];
        $dspopservico = $parametro["DESCRICAO"];
        
        $codnrtarefas = $this->newCode->getCodeByTableName("FCM_TAREFA", $nrorg, 1, 10, true);
        $dadosTarefas = array(
            "NRTAREFA" => $codnrtarefas,
            "NMTAREFA" => $nmtarefa,
            "NRATIVIDADE" => $nratividade,
            "DSPOPSERVICO" =>$dspopservico
        );
        
        $this->NovoChecklistFactory->insertTarefa($dadosTarefas);
        
        foreach($parametro["CRITERIO"] as $criterios) {
            
            $codnrcriterios = $this->newCode->getCodeByTableName("FCM_CRITERIOTAREFA", $nrorg, 1, 10, true);
            
            $dadosCriterios =  array(
                "NRCRITERIOTAREFA" => $codnrcriterios, 
                "DSCRITERIOTAREFA" => $criterios,
                "NRTAREFA" => $codnrtarefas,
                "IDTIPOCRITERIO" => 1
            );
            
            $this->NovoChecklistFactory->insertCriterio($dadosCriterios);

        }
        foreach($parametro["TAG"] as $tags) {
           $codnrtags = $this->newCode->getCodeByTableName("FCM_TAGSTAREFA", $nrorg, 1, 10, true); 
           
           $dadosTags = array(
               "NRTAGSTAREFA" => $codnrtags,
               "NRTAREFA" => $codnrtarefas,
               "DSTAGSTAREFA" => $tags
            );
            
            $this->NovoChecklistFactory->insertTag($dadosTags);
        }
            
    }

    public function insertChecklist($parametro, $nrorg) {
        $codnrchecklist = $this->newCode->getCodeByTableName("FCM_CHECKLIST",$nrorg, 1, 10, true);
        $retorno = array(
        "NRTIPOLOCALCLI" =>$parametro["tipoLocal"]["value"],
        "NRCHECKLIST" => $codnrchecklist,
        "NMCHECKLIST" => $parametro["nomeCheckList"],
        "DSCHECKLIST" => $parametro["descricaoChecklist"],
        "NRSETOR" => null,
        "NRCRITICIDADECHK" => null,
        "NRHABILIDADE" => null
        );
         $this->NovoChecklistFactory->insertNovoChecklistBase($retorno);
        
        
        foreach($parametro["itensChecklist"] as $itemChecklist) {
            $codnritemChecklist = $this->newCode->getCodeByTableName("FCM_ATIVIDADECHK",$nrorg, 1, 10, true);
            $retornoItem = array(
                "NRATIVIDADECHK" => $codnritemChecklist,
                "NRATIVIDADE" => $itemChecklist,
                "NRCHECKLIST" => $codnrchecklist
            );
            $this->NovoChecklistFactory->insertNovaAtividadeBase($retornoItem);
            
            foreach($parametro["selectTagTarefas"] as $tarefas){
              if($tarefas["parent"] == $itemChecklist){
                $codnrTarefa = $this->newCode->getCodeByTableName("FCM_TAREFACHK",$nrorg, 1, 10, true);
                $nrtarefa = $tarefas["value"];
                $retornoTarefa = array(
                    "NRTAREFACHK" => $codnrTarefa,
                    "NRTAREFA" => $nrtarefa,
                    "NRCHECKLIST" => $codnrchecklist,
                    "NRATIVIDADECHK" => $codnritemChecklist
                );
                
                $this->NovoChecklistFactory->insertNovaTarefaBase($retornoTarefa);
                
                foreach($parametro["dadosChip"] as $ind=>$dadosCard){
                  foreach($dadosCard as $chave=>$valor){
                    if ($chave == $nrtarefa) {
                      $dadosTag = array(
                          "DSTAGSTAREFA" => $ind,
                          "NRTAREFA" => $chave
                      );
                      
                      $retornoNumeroTag = $this->NovoChecklistFactory->getTag($dadosTag);
                      if (!empty($retornoNumeroTag)) {
                          $codnrTags = $this->newCode->getCodeByTableName("FCM_TAGSCHKTAREFA",$nrorg, 1, 10, true);
                          $dadosInsertTag = array(
                             "NRTAGSCHKTAREFA" => $codnrTags,
                             "NRTAGSTAREFA" => $retornoNumeroTag[0]["NRTAGSTAREFA"],
                             "NRTAREFACHK" => $codnrTarefa
                          );
                          $this->NovoChecklistFactory->insertNovoTagBase($dadosInsertTag);
            
                          foreach($dadosCard as $dadosCriterio) {
                              if($dadosCriterio != null ){
                                  foreach($dadosCriterio as $criterio){
                                      $codnrCriterio = $this->newCode->getCodeByTableName("FCM_CRITERIOTAREFACHK",$nrorg, 1, 10, true);
                                      
                                      $retornoCriterio = array(
                                          "NRCRITERIOTAREFACHK" => $codnrCriterio,
                                          "NRCRITERIOTAREFA" => $criterio, 
                                          "NRTAREFACHK" => $codnrTarefa
                                      );
                                      $this->NovoChecklistFactory->insertNovoCriterioBase($retornoCriterio);
                                      
                                      $codnrRelac = $this->newCode->getCodeByTableName("FCM_RELCRITERIOTAGTAREFACHK",$nrorg, 1, 10, true);
                                      
                                      $retornoRelac =array(
                                          "RELCRITERIOTAGTAREFACHK" => $codnrRelac,
                                          "NRCRITERIOTAREFACHK" => $codnrCriterio,
                                          "NRTAGSCHKTAREFA" => $codnrTags,
                                          "NRTAREFACHK" => $codnrTarefa
                                        );
                                        $this->NovoChecklistFactory->insertRelacCritTag($retornoRelac);
                                   }
                                }
                                
                            }
                        } 
                    }
                  }
              }
              
            }
          }
        }
    }

    public function validacaoChecklist($parametro){
        
        $param = array(
            "NRCHECKLIST" => $parametro
        );
        
        $retornoNrChecklist = $this->NovoChecklistFactory->validacaoChecklist($param);
        return $retornoNrChecklist;

    }
    
    public function validacaoTarefa($parametro){
        $param = array(
            "NRTAREFA" => $parametro["NRTAREFA"]
        );
        $retornoValidaTarefa = $this->NovoChecklistFactory->validacaoTarefa($param);
        return $retornoValidaTarefa;
    }
    
    public function validacaoCriterio($parametro){
        $variavel = implode(',',$parametro["NRCRITERIOTAREFA"]);
        $retornoValidaCriterio = $this->NovoChecklistFactory->validacaoCriterio($variavel);
        return $retornoValidaCriterio;
    }
    
    public function validacaoTag($parametro){
        $variavel = implode(',',$parametro["NRTAGSTAREFA"]);
        $retornoValidaTag = $this->NovoChecklistFactory->validacaoTag($variavel);
        return $retornoValidaTag;
    }

    public function updateChecklist($parametro, $nrorg, $nr){
        $retorno = array(
            "NMCHECKLIST" => $parametro["nomeCheckList"],
            "DSCHECKLIST" => $parametro["descricaoChecklist"],
            "NRCHECKLIST" => $nr
        );
        $this->NovoChecklistFactory->updateChecklist($retorno);
        
        $dadosDelete = $this->getDadosEditCard($nr);
        foreach($dadosDelete["ITEM"] as $itens) {
            $verificaIndice = array_key_exists("TAREFA", $itens);
            if($verificaIndice == true){
                foreach($itens['TAREFA'] as $tarefa){
                    $relacrCritTaf =  array(
                         "NRTAREFACHK" => $tarefa["NRTAREFACHK"]
                    );
                    $this->NovoChecklistFactory->deleteRelCriTag($relacrCritTaf);
                    $teste = array_key_exists("TAGS", $tarefa);
                    if($teste == true){
                      foreach($tarefa['TAGS'] as $tags){
                          $tagsADeletar = array(
                            "NRTAGSCHKTAREFA" => $tags["NRTAGSCHKTAREFA"]
                          );
                          $this->NovoChecklistFactory->deleteTagsChecklist($tagsADeletar);
                        }
                    }
                    $teste1 = array_key_exists("CRITERIOS", $tarefa);
                    if($teste1 == true){
                      foreach($tarefa["CRITERIOS"] as $criterio){
                          $criterioADeletar = array(
                            "NRCRITERIOTAREFACHK" => $criterio["NRCRITERIOTAREFACHK"]
                          );
                          $this->NovoChecklistFactory->deleteCriteriosChecklist($criterioADeletar);
                      }
                    }
                    $tarefaADeletar =  array(
                        "NRTAREFACHK" => $tarefa["NRTAREFACHK"]
                    );
                   $this->NovoChecklistFactory->deleteTarefaChecklist($tarefaADeletar);
                }
            }
            
            $itensADeletar =  array(
                "NRATIVIDADECHK" => $itens["NRATIVIDADECHK"]
            );
            $this->NovoChecklistFactory->deleteAtividadeChecklist($itensADeletar);
        }
        foreach($parametro["itensChecklist"] as $itemChecklist) {
            $codnritemChecklist = $this->newCode->getCodeByTableName("FCM_ATIVIDADECHK",$nrorg, 1, 10, true);
            $retornoItem = array(
                "NRATIVIDADECHK" => $codnritemChecklist,
                "NRATIVIDADE" => $itemChecklist,
                "NRCHECKLIST" => $nr
            );
            $this->NovoChecklistFactory->insertNovaAtividadeBase($retornoItem);
        }

        foreach($parametro["selectTagTarefas"] as $tarefas){
            $codnrTarefa = $this->newCode->getCodeByTableName("FCM_TAREFACHK",$nrorg, 1, 10, true);
            $nrtarefa = $tarefas["value"];
            $retornoTarefa = array(
                "NRTAREFACHK" => $codnrTarefa,
                "NRTAREFA" => $nrtarefa,
                "NRCHECKLIST" => $nr,
                "NRATIVIDADECHK" => $codnritemChecklist
            );
            $this->NovoChecklistFactory->insertNovaTarefaBase($retornoTarefa);
            foreach($parametro["dadosChip"] as $ind=>$dadosCard){
              $dadosTag = array(
                  "DSTAGSTAREFA" => $ind,
                  "NRTAREFA" => $nrtarefa
              );
              
              $retornoNumeroTag = $this->NovoChecklistFactory->getTag($dadosTag);
              if (!empty($retornoNumeroTag)) {
                  
                  $codnrTags = $this->newCode->getCodeByTableName("FCM_TAGSCHKTAREFA",$nrorg, 1, 10, true);
                  
                  $dadosInsertTag = array(
                     "NRTAGSCHKTAREFA" => $codnrTags,
                     "NRTAGSTAREFA" => $retornoNumeroTag[0]["NRTAGSTAREFA"],
                     "NRTAREFACHK" => $codnrTarefa
                  );
                  
                 $this->NovoChecklistFactory->insertNovoTagBase($dadosInsertTag);
        
                  foreach($dadosCard as $dadosCriterio) {
                      if($dadosCriterio != null ){
                          foreach($dadosCriterio as $criterio){
                              $codnrCriterio = $this->newCode->getCodeByTableName("FCM_CRITERIOTAREFACHK",$nrorg, 1, 10, true);
                              $retornoCriterio = array(
                                  "NRCRITERIOTAREFACHK" => $codnrCriterio,
                                  "NRCRITERIOTAREFA" => $criterio, 
                                  "NRTAREFACHK" => $codnrTarefa
                              );
                             $this->NovoChecklistFactory->insertNovoCriterioBase($retornoCriterio);
                             
                             $codnrRelac = $this->newCode->getCodeByTableName("FCM_RELCRITERIOTAGTAREFACHK",$nrorg, 1, 10, true);
                             
                             $retornoRelac =array(
                              "RELCRITERIOTAGTAREFACHK" => $codnrRelac,
                              "NRCRITERIOTAREFACHK" => $codnrCriterio,
                              "NRTAGSCHKTAREFA" => $codnrTags,
                              "NRTAREFACHK" => $codnrTarefa
                            );
                            
                            $this->NovoChecklistFactory->insertRelacCritTag($retornoRelac);
                            
                            }
                        }
                      
                    }
                }
            }
        }
    }
    
    public function deletaTarefaAtividade($nrCriterioTarefa, $nrTagsTarefa,$nrTarefa) {
        foreach($nrCriterioTarefa as $criterio){
            $param =  array(
               "NRCRITERIOTAREFA" => $criterio
            );
            $this->NovoChecklistFactory->deletaCriterio($param);
        }
        
        foreach($nrTagsTarefa as $tag){
            $param =  array(
               "NRTAGSTAREFA" => $tag
            );
            $this->NovoChecklistFactory->deletaTag($param);
        }
        
        $param =  array(
           "NRTAREFA" => $nrTarefa
        );        
        
        $this->NovoChecklistFactory->deletaTarefa($param);

    }
    
    public function deletaAtividade($nrAtividade) {

        $param =  array(
           "NRATIVIDADE" => $nrAtividade
        );        
        
        $this->NovoChecklistFactory->deletaAtividade($param);

    }
    
    public function deleteChecklist($nr) {
        $dadosDelete = $this->getDadosEditCard($nr);

        foreach($dadosDelete["ITEM"] as $itens) {
            $verificaIndice = array_key_exists("TAREFA", $itens);
            if($verificaIndice == true){
                foreach($itens['TAREFA'] as $tarefa){
                    $relacrCritTaf =  array(
                         "NRTAREFACHK" => $tarefa["NRTAREFACHK"]
                    );
                    $this->NovoChecklistFactory->deleteRelCriTag($relacrCritTaf);
                    $teste = array_key_exists("TAGS", $tarefa);
                    if($teste == true){
                      foreach($tarefa['TAGS'] as $tags){
                          $tagsADeletar = array(
                            "NRTAGSCHKTAREFA" => $tags["NRTAGSCHKTAREFA"]
                          );
                          $this->NovoChecklistFactory->deleteTagsChecklist($tagsADeletar);
                        }
                    }
                    $teste1 = array_key_exists("CRITERIOS", $tarefa);
                    if($teste1 == true){
                      foreach($tarefa["CRITERIOS"] as $criterio){
                          $criterioADeletar = array(
                            "NRCRITERIOTAREFACHK" => $criterio["NRCRITERIOTAREFACHK"]
                          );
                          $this->NovoChecklistFactory->deleteCriteriosChecklist($criterioADeletar);
                      }
                    }
                    $tarefaADeletar =  array(
                        "NRTAREFACHK" => $tarefa["NRTAREFACHK"]
                    );
                   $this->NovoChecklistFactory->deleteTarefaChecklist($tarefaADeletar);
                }
            }
            
            $itensADeletar =  array(
                "NRATIVIDADECHK" => $itens["NRATIVIDADECHK"]
            );
            $this->NovoChecklistFactory->deleteAtividadeChecklist($itensADeletar);
        }
        $paramChecklist =  array(
            "NRCHECKLIST" => $nr
        );
        $this->NovoChecklistFactory->deleteChecklist($paramChecklist);
    }
    
    public function changeColorActivity($parametro){
        $param = array(
            "NRATIVIDADE" => intval($parametro['nr']),
            "DSCORIDATIVIDADE" => "#".$parametro['color']
        );
        $this->NovoChecklistFactory->changeColorActivity($param);
        return "OK";
    }
}
?>