/* Tabela NOTAFISCAL */

/* Descrio: Ao lanar uma nota fiscal de entrada  verificado se para a filial de origem e fornecedor j possui
   alguma nota fiscal lanada com o nmero informado no campo Natureza de Operao da tela de Lanamento de Nota
   Fiscal, caso exista ao fechar a nota fiscal  exibida a mensagem: Operao bloqueada! Nmero de nota fiscal j
   cadastrado.*/

/* Objetivo: Impedir que sejam realizados lanamentos repetidos de nota fiscal de entrada, especifica do cliente
   Eurest*/

/* @C:\web_565\sql\end_conv\oracle\clientes\cch\0001_EMBTRGO_EMB_BLOQ_LANC_REP.SQL
	Criao:
	19/12/2011 - Jefferson de Melo Gouvea */

DROP TRIGGER EMB_BLOQ_LANC_REP
/

CREATE OR REPLACE TRIGGER EMB_BLOQ_LANC_REP
BEFORE INSERT OR UPDATE ON ITEMPRODUTO FOR EACH ROW
DECLARE
   V_NOTA  		NUMBER;
   V_CDFILIRECE 	NOTAFISCAL.CDFILIRECE%TYPE;
   V_DSCDFISOPENF       NOTAFISCAL.DSCDFISOPENF%TYPE;
   V_NRINSJURNF 	NOTAFISCAL.NRINSJURNF%TYPE;
   V_CDFILIAL           NOTAFISCAL.CDFILIAL%TYPE;
   V_NRLANCTONF         NOTAFISCAL.NRLANCTONF%TYPE;
   V_CDTIPOOPER         NOTAFISCAL.CDTIPOOPER%TYPE;
   V_EXISTE             INTEGER;
   V_IDENTRSAIDOP       NOTAFISCAL.IDENTRSAIDOP%TYPE;
BEGIN
   V_NRINSJURNF   := '';
   V_DSCDFISOPENF := '';
   V_CDFILIRECE   := '';
   V_CDTIPOOPER   := '';
   V_NOTA 	  := 0;
   V_EXISTE       := 0;
   V_IDENTRSAIDOP := '';

   BEGIN
      SELECT NVL(MAX(N.CDFILIAL),''),NVL(MAX(N.NRLANCTONF),''), NVL(MAX(N.CDFILIRECE),''), NVL(MAX(N.DSCDFISOPENF),''), NVL(MAX(N.NRINSJURNF),''),
             MAX(CDTIPOOPER), MAX(IDENTRSAIDOP)
        INTO V_CDFILIAL, V_NRLANCTONF, V_CDFILIRECE, V_DSCDFISOPENF, V_NRINSJURNF,
             V_CDTIPOOPER, V_IDENTRSAIDOP
        FROM NOTAFISCAL N, ENDEFILI E
       WHERE N.CDFILIAL     = :NEW.CDFILIAL
         AND N.CDFILIRECE   = E.CDFILIAL
         AND N.NRLANCTONF   = :NEW.NRLANCTONF
         AND N.IDENTRSAIDOP = 'E'
         AND N.IDSISTEMA    = 'DFE'
         AND N.CDTIPOOPER   IN ('01','08')
         AND E.IDTPENDEFILI = 'P'
  	 AND E.CDPAIS       = '0057';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDFILIAL     := NULL;
         V_NRLANCTONF   := NULL;
         V_CDFILIRECE   := NULL;
         V_DSCDFISOPENF := NULL;
         V_NRINSJURNF   := NULL;
         V_CDTIPOOPER   := NULL;
         V_IDENTRSAIDOP := NULL;
   END;

   SELECT COUNT(1)
     INTO V_EXISTE
     FROM ITEMNOTAFISC
    WHERE CDFILIALIT = V_CDFILIAL
      AND NRLANCTONFIT = V_NRLANCTONF;

   IF (V_EXISTE = 0) AND (V_IDENTRSAIDOP = 'E') THEN
      IF NOT (V_DSCDFISOPENF IS NULL) THEN
         SELECT COUNT(N.NRLANCTONF)
           INTO V_NOTA
           FROM NOTAFISCAL N, ENDEFILI E
          WHERE N.CDFILIRECE   = V_CDFILIRECE
            AND UPPER(N.DSCDFISOPENF) = UPPER(V_DSCDFISOPENF)
            AND N.NRINSJURNF   = V_NRINSJURNF
            AND N.IDENTRSAIDOP = 'E'
            AND N.IDSISTEMA    = 'DFE'
            AND N.CDTIPOOPER   = V_CDTIPOOPER
            AND E.CDFILIAL     = V_CDFILIRECE
            AND E.IDTPENDEFILI = 'P'
            AND E.CDPAIS       = '0057';
         IF (V_NOTA > 1) THEN
            RAISE_APPLICATION_ERROR(-20501, 'Operacin bloqueada! Nmero de factura ya registrado.', TRUE);
         ELSE
            SELECT COUNT(1)
              INTO V_NOTA
              FROM ENDEFILI
             WHERE LENGTH(REGEXP_REPLACE(V_DSCDFISOPENF,'[^a-z0-9A-Z\-]',NULL)) = LENGTH(V_DSCDFISOPENF)
               AND CDFILIAL     = V_CDFILIRECE
               AND IDTPENDEFILI = 'P'
               AND CDPAIS       = '0057';
            IF (V_NOTA = 0) THEN
               RAISE_APPLICATION_ERROR(-20501, 'Operacin bloqueada! Nmero de factura posee caracteres invlidos.', TRUE);
               END IF;
         END IF;
      ELSE
         RAISE_APPLICATION_ERROR(-20501, 'Operacin bloqueada! Nmero de factura deve ser informado.', TRUE);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EMB_BLOQ_LANC_REP','5.65.XXX'); END;
/